SystemOrganization addCategory: #DevPacerCommon!

Object subclass: #ISPState
	instanceVariableNames: 'message color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!ISPState classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/26/2012 17:34'!
color: aColor message: aString

	^self new
		color: aColor;
		message: aString  ! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:54'!
color

	^ color! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:33'!
color: aColor
	color := aColor! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:33'!
message
	^ message! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:33'!
message: aString
	message := aString! !

Object subclass: #UnitPacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

UnitPacer class
	instanceVariableNames: 'DueTime RunningAni IntervalMinutes'!

UnitPacer class
	instanceVariableNames: 'DueTime RunningAni IntervalMinutes'!

UnitPacer subclass: #CommitPacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!CommitPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:09'!
defaultIntervalMinutes
	^ 15! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 13:57'!
grayState

	^ISPState color: Color gray message: ['Not checking'].! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 14:11'!
greenState

	^ISPState color: Color green message: ['All packages are clean.']! !

!CommitPacer classSide methodsFor: 'gui' stamp: 'hjo 4/27/2012 19:06'!
helpName

	^'commit pacer'! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 14:05'!
redState

	^ISPState color: Color red message: ['COMMIT NOW!!!!'].    ! !

!CommitPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:10'!
settingsItemOn: aBuilder

	<systemsettings>
	(aBuilder pickOne: #displayDepth) 
		label: 'Commit pacing interval (in minutes)' translated;
		parent: #DevPacer;
		target: #CommitPacer; 
		getSelector: #intervalMinutes;
		setSelector: #intervalMinutes:;
		domainValues: #(2 5 10 15 30);
		default: self defaultIntervalMinutes;
		notInStyle.! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 12:19'!
somePackageIsDirty

	^MCWorkingCopy allManagers anySatisfy: [:wc| wc needsSaving ]  ! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 4/11/2012 20:20'!
state

	self isRunning not ifTrue: [^self grayState].
	CommitPacer somePackageIsDirty not ifTrue: [
		DueTime := nil.
		^self greenState
		].
	DueTime isNil ifTrue: [ 
		DueTime := DateAndTime now + (Duration minutes: self intervalMinutes).
		^self yellowState ].
	DueTime < (DateAndTime now) ifTrue: [^self redState].
	^self yellowState.! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 4/20/2012 16:07'!
yellowState

	^ISPState color: Color yellow message: ['Commit after ', self countDownString].! !

UnitPacer subclass: #ImageSavePacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!ImageSavePacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:10'!
defaultIntervalMinutes
	^ 2! !

!ImageSavePacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 12:13'!
grayState

	^ISPState color: Color gray message: ['Not monitoring'].! !

!ImageSavePacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 12:13'!
greenState

	^ISPState color: Color green message: ['No need to save image.'].    
! !

!ImageSavePacer classSide methodsFor: 'gui' stamp: 'hjo 4/27/2012 19:07'!
helpName

	^'image pacer'! !

!ImageSavePacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 14:12'!
redState

	^ISPState color: Color red message: ['SAVE NEW IMAGE NOW!!'].    ! !

!ImageSavePacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:10'!
settingsItemOn: aBuilder

	<systemsettings>
	(aBuilder pickOne: #displayDepth) 
		label: 'Image save pacing interval (in minutes)' translated;
		parent: #DevPacer;
		target: #ImageSavePacer; 
		getSelector: #intervalMinutes;
		setSelector: #intervalMinutes:;
		domainValues: #(1 2 3 5 10 15);
		default: self defaultIntervalMinutes;
		notInStyle.! !

!ImageSavePacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 14:42'!
state

	self isRunning not ifTrue: [^self grayState].
	DueTime isNil ifTrue: [ ^self greenState ].
	DueTime < (DateAndTime now) ifTrue: [^self redState].
	^self yellowState.! !

!ImageSavePacer classSide methodsFor: 'interface' stamp: 'hjo 4/20/2012 17:29'!
systemChanged
	
	DueTime isNil
	ifTrue: [DueTime := DateAndTime now + (Duration minutes: self intervalMinutes)]
	! !

!ImageSavePacer classSide methodsFor: 'interface' stamp: 'hjo 4/7/2012 20:43'!
systemSaved

	DueTime := nil.
	self changed: #statusColor.
	self changed: #getStatusText.! !

!ImageSavePacer classSide methodsFor: 'states' stamp: 'hjo 4/20/2012 16:07'!
yellowState

	^ISPState color: Color yellow message: ['Should save image after ', self countDownString].! !

UnitPacer subclass: #TestPacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!TestPacer classSide methodsFor: 'interface' stamp: 'hjo 4/11/2012 11:31'!
colorOfTestRunnerGotGreen

	DueTime := nil.! !

!TestPacer classSide methodsFor: 'interface' stamp: 'hjo 4/11/2012 17:54'!
colorOfTestRunnerGotNotGreen

	DueTime isNil
	ifTrue: [DueTime := DateAndTime now + (Duration minutes: 4)]! !

!TestPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:13'!
defaultIntervalMinutes
	^ 3! !

!TestPacer classSide methodsFor: 'states' stamp: 'hjo 4/11/2012 11:34'!
grayState

	^ISPState color: Color gray message: ['Not checking'].! !

!TestPacer classSide methodsFor: 'states' stamp: 'hjo 4/11/2012 11:38'!
greenState

	^ISPState color: Color green message: ['Test Pass'].    
! !

!TestPacer classSide methodsFor: 'gui' stamp: 'hjo 4/27/2012 19:07'!
helpName

	^'test pacer'! !

!TestPacer classSide methodsFor: 'states' stamp: 'hjo 4/11/2012 11:40'!
redState

	^ISPState color: Color red message: ['DO ANYTHING TO MAKE IT GREEN!!'].    ! !

!TestPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:13'!
settingsItemOn: aBuilder

	<systemsettings>
	(aBuilder pickOne: #displayDepth) 
		label: 'Test pacing interval (in minutes)' translated;
		parent: #DevPacer;
		target: #TestPacer; 
		getSelector: #intervalMinutes;
		setSelector: #intervalMinutes:;
		domainValues: #(1 2 3 5 10 15);
		default: self defaultIntervalMinutes;
		notInStyle.! !

!TestPacer classSide methodsFor: 'states' stamp: 'hjo 4/11/2012 11:41'!
state

	self isRunning not ifTrue: [^self grayState].
	DueTime isNil ifTrue: [ ^self greenState ].
	DueTime < (DateAndTime now) ifTrue: [^self redState].
	^self yellowState.! !

!TestPacer classSide methodsFor: 'states' stamp: 'hjo 4/20/2012 16:07'!
yellowState

	^ISPState color: Color yellow message: ['Should pass after ', self countDownString].! !

!UnitPacer classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 16:06'!
countDownString

	^(DueTime - DateAndTime now) printString copyFrom:6 to: 10! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 3/31/2012 14:52'!
getStatusText

	^self state message value! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 3/31/2012 14:53'!
getStatusTextIsEnabled

	^true! !

!UnitPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:09'!
intervalMinutes
	IntervalMinutes isNil
		ifTrue: [ IntervalMinutes := self defaultIntervalMinutes ].
	^ IntervalMinutes! !

!UnitPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:09'!
intervalMinutes: anInteger

	IntervalMinutes := anInteger.! !

!UnitPacer classSide methodsFor: 'running' stamp: 'hjo 3/31/2012 14:54'!
isRunning

	^RunningAni notNil and: [RunningAni isStepping]! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 4/27/2012 19:08'!
menuCommandOn: aBuilder
	<worldMenu>
	(aBuilder item: #'open AutoImageSave Morph')
		parent: #Tools;
		order: 4;
		icon: self taskbarIcon;
		label: 'DevPacer';
		action: [ 
			| imageSavePanel commitPanel testPanel win |
			imageSavePanel := ImageSavePacer morphPanel.
			commitPanel := CommitPacer morphPanel.
			testPanel := TestPacer morphPanel.
			win := (UITheme builder newColumn: {imageSavePanel. commitPanel. testPanel}) openInWindowLabeled: 'DevPacer'.
			win extent:  (271@134).
			win model: self ]! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 4/27/2012 19:07'!
morphPanel
	| t b cp win c |
	b := UITheme builder.
	cp := b newColorPresenterFor: self getColor: #statusColor help: 'this show whether time has expired or not.'.
	t := b newLabelFor: self getLabel: #getStatusText  getEnabled:  #getStatusTextIsEnabled.
	c := b
		newCheckboxFor: self
		getSelected: #isRunning
		setSelected: #setPacerRunning:
		getEnabled: #shouldCheckboxEnabled
		label: ''
		help: 'You can turn off the ', self helpName.
	^ b newGroupboxForAll: {b newRow: {c. b newStack:{t.cp}}}.
! !

!UnitPacer classSide methodsFor: 'running' stamp: 'hjo 3/31/2012 14:54'!
myOperation.

	self changed: #statusColor.
	self changed: #getStatusText.
! !

!UnitPacer classSide methodsFor: 'running' stamp: 'hjo 3/31/2012 14:54'!
run

	RunningAni isNil ifTrue: [ 
			RunningAni := EndlessAni new.
			RunningAni stepTime: 500.
			RunningAni operation: (MessageSend receiver: self selector: #myOperation).
			].
	RunningAni startStepping.! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 3/31/2012 14:53'!
setPacerRunning: aBoolean

	self perform: (aBoolean ifTrue: [ #run ] ifFalse: [ #stop ]).! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 3/31/2012 14:53'!
shouldCheckboxEnabled

	^true! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 3/31/2012 14:53'!
statusColor

	^self state color.! !

!UnitPacer classSide methodsFor: 'running' stamp: 'hjo 3/31/2012 14:54'!
stop

	RunningAni isNil ifFalse: [ RunningAni stopStepping ].
	self changed: #statusColor.
	self changed: #getStatusText.
	self changed: #isRunning.! !

!UnitPacer classSide methodsFor: 'running' stamp: 'hjo 3/31/2012 14:55'!
strongStop

	self stop.
	RunningAni := nil.! !

!UnitPacer classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2012 20:05'!
taskbarIcon 

	^ThemeIcons smallJumpIcon.! !

!UnitPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:15'!
userStyleOn: aBuilder 
	<systemsettings>
	(aBuilder group: #DevPacer) label: 'DevPacer' translated! !
